
/* Translate from SDL SDLK_* keysyms to the Mac MKV_* keysyms */

#define NOTAKEY	0x89

static unsigned char sdlk_to_mkv[256] = 
{
/*			[0] */		NOTAKEY,
/*			[1] */		NOTAKEY,
/*			[2] */		NOTAKEY,
/*			[3] */		NOTAKEY,
/*			[4] */		NOTAKEY,
/*			[5] */		NOTAKEY,
/*			[6] */		NOTAKEY,
/*			[7] */		NOTAKEY,
/* SDLK_BACKSPACE	[8] */		MKV_BACKSPACE,
/* SDLK_TAB		[9] */		MKV_TAB,
/*			[10] */		NOTAKEY,
/*			[11] */		NOTAKEY,
/* SDLK_CLEAR		[12] */		NOTAKEY,
/* SDLK_RETURN		[13] */		MKV_RETURN,
/*			[14] */		NOTAKEY,
/*			[15] */		NOTAKEY,
/*			[16] */		NOTAKEY,
/*			[17] */		NOTAKEY,
/*			[18] */		NOTAKEY,
/*			[19] */		NOTAKEY,
/*			[20] */		NOTAKEY,
/*			[21] */		NOTAKEY,
/*			[22] */		NOTAKEY,
/*			[23] */		NOTAKEY,
/*			[24] */		NOTAKEY,
/*			[25] */		NOTAKEY,
/*			[26] */		NOTAKEY,
/* SDLK_ESCAPE		[27] */		MKV_ESCAPE,
/*			[28] */		NOTAKEY,
/*			[29] */		NOTAKEY,
/*			[30] */		NOTAKEY,
/*			[31] */		NOTAKEY,
/* SDLK_SPACE		[32] */		MKV_SPACE,
/*			[33] */		NOTAKEY,
/*			[34] */		NOTAKEY,
/*			[35] */		NOTAKEY,
/*			[36] */		NOTAKEY,
/*			[37] */		NOTAKEY,
/*			[38] */		NOTAKEY,
/* SDLK_QUOTE		[39] */		MKV_TICK,
/*			[40] */		NOTAKEY,
/*			[41] */		NOTAKEY,
/*			[42] */		NOTAKEY,
/*			[43] */		NOTAKEY,
/* SDLK_COMMA		[44] */		MKV_COMMA,
/* SDLK_MINUS		[45] */		MKV_MINUS,
/* SDLK_PERIOD		[46] */		MKV_PERIOD,
/* SDLK_SLASH		[47] */		MKV_SLASH,
/* SDLK_0		[48] */		MKV_0,
/* SDLK_1		[49] */		MKV_1,
/* SDLK_2		[50] */		MKV_2,
/* SDLK_3		[51] */		MKV_3,
/* SDLK_4		[52] */		MKV_4,
/* SDLK_5		[53] */		MKV_5,
/* SDLK_6		[54] */		MKV_6,
/* SDLK_7		[55] */		MKV_7,
/* SDLK_8		[56] */		MKV_8,
/* SDLK_9		[57] */		MKV_9,
/*			[58] */		NOTAKEY,
/* SDLK_SEMICOLON	[59] */		MKV_SEMI,
/*			[60] */		NOTAKEY,
/* SDLK_EQUALS		[61] */		MKV_EQUAL,
/*			[62] */		NOTAKEY,
/*			[63] */		NOTAKEY,
/*			[64] */		NOTAKEY,
/*			[65] */		NOTAKEY,
/*			[66] */		NOTAKEY,
/*			[67] */		NOTAKEY,
/*			[68] */		NOTAKEY,
/*			[69] */		NOTAKEY,
/* SDLK_KP0		[70] */		MKV_NUM0,
/* SDLK_KP1		[71] */		MKV_NUM1,
/* SDLK_KP2		[72] */		MKV_NUM2,
/* SDLK_KP3		[73] */		MKV_NUM3,
/* SDLK_KP4		[74] */		MKV_NUM4,
/* SDLK_KP5		[75] */		MKV_NUM5,
/* SDLK_KP6		[76] */		MKV_NUM6,
/* SDLK_KP7		[77] */		MKV_NUM7,
/* SDLK_KP8		[78] */		MKV_NUM8,
/* SDLK_KP9		[79] */		MKV_NUM9,
/* SDLK_KP_PERIOD	[80] */		MKV_NUMPOINT,
/* SDLK_KP_DIVIDE	[81] */		MKV_NUMDIVIDE,
/* SDLK_KP_MULTIPLY	[82] */		MKV_NUMMULTIPLY,
/* SDLK_KP_MINUS	[83] */		MKV_NUMMINUS,
/* SDLK_KP_PLUS		[84] */		MKV_NUMPLUS,
/* SDLK_KP_ENTER	[85] */		MKV_NUMENTER,
/*			[86] */		NOTAKEY,
/*			[87] */		NOTAKEY,
/*			[88] */		NOTAKEY,
/*			[89] */		NOTAKEY,
/*			[90] */		NOTAKEY,
/* SDLK_LEFTBRACKET	[91] */		MKV_LEFTBRACKET,
/* SDLK_BACKSLASH	[92] */		MKV_BACKSLASH,
/* SDLK_RIGHTBRACKET	[93] */		MKV_RIGHTBRACKET,
/*			[94] */		NOTAKEY,
/*			[95] */		NOTAKEY,
/* SDLK_BACKQUOTE	[96] */		MKV_BACKTICK,
/* SDLK_a		[97] */		MKV_a,
/* SDLK_b		[98] */		MKV_b,
/* SDLK_c		[99] */		MKV_c,
/* SDLK_d		[100] */	MKV_d,
/* SDLK_e		[101] */	MKV_e,
/* SDLK_f		[102] */	MKV_f,
/* SDLK_g		[103] */	MKV_g,
/* SDLK_h		[104] */	MKV_h,
/* SDLK_i		[105] */	MKV_i,
/* SDLK_j		[106] */	MKV_j,
/* SDLK_k		[107] */	MKV_k,
/* SDLK_l		[108] */	MKV_l,
/* SDLK_m		[109] */	MKV_m,
/* SDLK_n		[110] */	MKV_n,
/* SDLK_o		[111] */	MKV_o,
/* SDLK_p		[112] */	MKV_p,
/* SDLK_q		[113] */	MKV_q,
/* SDLK_r		[114] */	MKV_r,
/* SDLK_s		[115] */	MKV_s,
/* SDLK_t		[116] */	MKV_t,
/* SDLK_u		[117] */	MKV_u,
/* SDLK_v		[118] */	MKV_v,
/* SDLK_w		[119] */	MKV_w,
/* SDLK_x		[120] */	MKV_x,
/* SDLK_y		[121] */	MKV_y,
/* SDLK_z		[122] */	MKV_z,
/*			[123] */	NOTAKEY,
/*			[124] */	NOTAKEY,
/*			[125] */	NOTAKEY,
/*			[126] */	NOTAKEY,
/* SDLK_DELETE		[127] */	MKV_DELFORWARD,
/* SDLK_F1		[128] */	MKV_F1,
/* SDLK_F2		[129] */	MKV_F2,
/* SDLK_F3		[130] */	MKV_F3,
/* SDLK_F4		[131] */	MKV_F4,
/* SDLK_F5		[132] */	MKV_F5,
/* SDLK_F6		[133] */	MKV_F6,
/* SDLK_F7		[134] */	MKV_F7,
/* SDLK_F8		[135] */	MKV_F8,
/* SDLK_F9		[136] */	MKV_F9,
/* SDLK_F10		[137] */	MKV_F10,
/* SDLK_F11		[138] */	MKV_F11,
/* SDLK_F12		[139] */	MKV_F12,
/* SDLK_F13		[140] */	MKV_F13,
/* SDLK_F14		[141] */	MKV_F14,
/* SDLK_F15		[142] */	MKV_F15,
/* SDLK_PAUSE		[143] */	MKV_PAUSE,
/* SDLK_NUMLOCK		[144] */	MKV_NUMCLEAR,
/* SDLK_UP		[145] */	MKV_UPARROW,
/* SDLK_DOWN		[146] */	MKV_DOWNARROW,
/* SDLK_RIGHT		[147] */	MKV_RIGHTARROW,
/* SDLK_LEFT		[148] */	MKV_LEFTARROW,
/* SDLK_INSERT		[149] */	MKV_HELP,
/* SDLK_HOME		[150] */	MKV_HOME,
/* SDLK_END		[151] */	MKV_END,
/* SDLK_PAGEUP		[152] */	MKV_PAGEUP,
/* SDLK_PAGEDOWN	[153] */	MKV_PAGEDOWN,
/* SDLK_CAPSLOCK	[154] */	MKV_CAPS,
/* SDLK_SCROLLOCK	[155] */	MKV_SCROLL_LOCK,
/* SDLK_RSHIFT		[156] */	MKV_RIGHTSHIFT,
/* SDLK_LSHIFT		[157] */	MKV_LEFTSHIFT,
/* SDLK_RCTRL		[158] */	MKV_RIGHTCNTL,
/* SDLK_LCTRL		[159] */	MKV_LEFTCNTL,
/* SDLK_RALT		[160] */	MKV_RIGHTOPTION,
/* SDLK_LALT		[161] */	MKV_CLOVER,
/* SDLK_RMETA		[162] */	MKV_RIGHTOPTION,
/* SDLK_LMETA		[163] */	MKV_CLOVER,
/* SDLK_HELP		[164] */	MKV_HELP,
/* SDLK_PRINT		[165] */	MKV_PRINT_SCREEN,
/* SDLK_SYSREQ		[166] */	NOTAKEY,
/* SDLK_MENU		[167] */	NOTAKEY,
/* SDLK_BREAK		[168] */	NOTAKEY,
/*			[169] */	NOTAKEY,
/*			[170] */	NOTAKEY,
/*			[171] */	NOTAKEY,
/*			[172] */	NOTAKEY,
/*			[173] */	NOTAKEY,
/*			[174] */	NOTAKEY,
/*			[175] */	NOTAKEY,
/*			[176] */	NOTAKEY,
/*			[177] */	NOTAKEY,
/*			[178] */	NOTAKEY,
/*			[179] */	NOTAKEY,
/*			[180] */	NOTAKEY,
/*			[181] */	NOTAKEY,
/*			[182] */	NOTAKEY,
/*			[183] */	NOTAKEY,
/*			[184] */	NOTAKEY,
/*			[185] */	NOTAKEY,
/*			[186] */	NOTAKEY,
/*			[187] */	NOTAKEY,
/*			[188] */	NOTAKEY,
/*			[189] */	NOTAKEY,
/*			[190] */	NOTAKEY,
/*			[191] */	NOTAKEY,
/*			[192] */	NOTAKEY,
/*			[193] */	NOTAKEY,
/*			[194] */	NOTAKEY,
/*			[195] */	NOTAKEY,
/*			[196] */	NOTAKEY,
/*			[197] */	NOTAKEY,
/*			[198] */	NOTAKEY,
/*			[199] */	NOTAKEY,
/*			[200] */	NOTAKEY,
/*			[201] */	NOTAKEY,
/*			[202] */	NOTAKEY,
/*			[203] */	NOTAKEY,
/*			[204] */	NOTAKEY,
/*			[205] */	NOTAKEY,
/*			[206] */	NOTAKEY,
/*			[207] */	NOTAKEY,
/*			[208] */	NOTAKEY,
/*			[209] */	NOTAKEY,
/*			[210] */	NOTAKEY,
/*			[211] */	NOTAKEY,
/*			[212] */	NOTAKEY,
/*			[213] */	NOTAKEY,
/*			[214] */	NOTAKEY,
/*			[215] */	NOTAKEY,
/*			[216] */	NOTAKEY,
/*			[217] */	NOTAKEY,
/*			[218] */	NOTAKEY,
/*			[219] */	NOTAKEY,
/*			[220] */	NOTAKEY,
/*			[221] */	NOTAKEY,
/*			[222] */	NOTAKEY,
/*			[223] */	NOTAKEY,
/*			[224] */	NOTAKEY,
/*			[225] */	NOTAKEY,
/*			[226] */	NOTAKEY,
/*			[227] */	NOTAKEY,
/*			[228] */	NOTAKEY,
/*			[229] */	NOTAKEY,
/*			[230] */	NOTAKEY,
/*			[231] */	NOTAKEY,
/*			[232] */	NOTAKEY,
/*			[233] */	NOTAKEY,
/*			[234] */	NOTAKEY,
/*			[235] */	NOTAKEY,
/*			[236] */	NOTAKEY,
/*			[237] */	NOTAKEY,
/*			[238] */	NOTAKEY,
/*			[239] */	NOTAKEY,
/*			[240] */	NOTAKEY,
/*			[241] */	NOTAKEY,
/*			[242] */	NOTAKEY,
/*			[243] */	NOTAKEY,
/*			[244] */	NOTAKEY,
/*			[245] */	NOTAKEY,
/*			[246] */	NOTAKEY,
/*			[247] */	NOTAKEY,
/*			[248] */	NOTAKEY,
/*			[249] */	NOTAKEY,
/*			[250] */	NOTAKEY,
/*			[251] */	NOTAKEY,
/*			[252] */	NOTAKEY,
/*			[253] */	NOTAKEY,
/*			[254] */	NOTAKEY,
/*			[255] */	NOTAKEY,
};
