/* Copyright 1994, 1995, 1996 by Abacus Research and
 * Development, Inc.  All rights reserved.
 */

#if !defined (OMIT_RCSID_STRINGS)
char ROMlib_rcsid_emutraptables[] =
		"$Id: emutraptables.c 63 2004-12-24 18:19:43Z ctm $";
#endif

#include "rsys/common.h"
#include "rsys/everything.h"

#include "OSUtil.h"
#include "Gestalt.h"
#include "SysErr.h"

#include "rsys/trapglue.h"
#include "rsys/ptocflags.h"
#include "rsys/stdfile.h"
#include "rsys/tesave.h"
#include "rsys/resource.h"
#include "rsys/ctl.h"
#include "rsys/list.h"
#include "rsys/menu.h"
#include "rsys/wind.h"
#include "rsys/print.h"
#include "rsys/osutil.h"
#include "rsys/vbl.h"
#include "rsys/soundopts.h"
#include "rsys/refresh.h"
#include "rsys/gestalt.h"
#include "rsys/emustubs.h"

void *tooltraptable[0x400];	/* Gets filled in at run time */
void   *ostraptable[0x100];	/* Gets filled in at run time */

#define C_Pack9  (void *) _Unimplemented /* PPCBrowser */
#define PTOC_Pack9  -1
#define C_Pack10  (void *) _Unimplemented
#define PTOC_Pack10  -1

#define C_Pack13  (void *) _Unimplemented /* DB stuff */
#define PTOC_Pack13  -1
#define C_Pack1  (void *) _Unimplemented
#define PTOC_Pack1  -1
#define C_Chain  (void *) _Unimplemented
#define PTOC_Chain  -1

#define _AddDrive _Unimplemented
#define _RDrvrInstall _Unimplemented
/* #define _IMVI_ReadXPRam _Unimplemented */
#define _IMVI_WriteXPRam _Unimplemented
#define _IMVI_MemoryDispatch _Unimplemented
/* #define _SlotManager _Unimplemented */
/* #define _SlotVInstall _Unimplemented */
/* #define _SlotVRemove _Unimplemented */
#define _AttachVBL _Unimplemented
#define _DoVBLTask _Unimplemented
#define _DTInstall _Unimplemented
#define _SIntRemove _Unimplemented
#define _InternalWait _Unimplemented
#define _SIntInstall _Unimplemented
#define _IMVI_IdleUpdate _Unimplemented
#define _IMVI_SlpQInstall _Unimplemented
#define _IMVI_DebugUtil _Unimplemented
#define _IMVI_DeferUserFn _Unimplemented
#define _IMVI_Translate24To32 _Unimplemented

#define _GetMaskTable	_Unimplemented
#define _Debugger	_Unimplemented
#define _DebugStr	_Unimplemented


void C_unknown574 (void)
{
}

toolstuff_t toolstuff[0x400] = {
    { { _SoundDispatch, -1 }, (void *) 0 },
    { { C_SndDisposeChannel, PTOC_SndDisposeChannel }, (void *) 0 },
    { { C_SndAddModifier, PTOC_SndAddModifier }, (void *) 0 },
    { { C_SndDoCommand, PTOC_SndDoCommand }, (void *) 0 },
    { { C_SndDoImmediate, PTOC_SndDoImmediate }, (void *) 0 },
    { { C_SndPlay, PTOC_SndPlay }, (void *) 0 },
    { { C_SndControl, PTOC_SndControl }, (void *) 0 },
    { { C_SndNewChannel, PTOC_SndNewChannel }, (void *) 0 },
    { { C_InitProcMenu, PTOC_InitProcMenu }, (void *) 0 },
    { { C_GetCVariant, PTOC_GetCVariant }, (void *) 0 },
    { { C_GetWVariant, PTOC_GetWVariant }, (void *) 0 },
    { { C_PopUpMenuSelect, PTOC_PopUpMenuSelect }, (void *) 0 },
    { { C_RGetResource, PTOC_RGetResource }, (void *) 0 },
    { { C_Count1Resources, PTOC_Count1Resources }, (void *) 0 },
    { { C_Get1IndResource, PTOC_Get1IndResource }, (void *) 0 },
    { { C_Get1IndType, PTOC_Get1IndType }, (void *) 0 },
    { { C_Unique1ID, PTOC_Unique1ID }, (void *) 0 },
    { { C_TESelView, PTOC_TESelView }, (void *) 0 },
    { { C_TEPinScroll, PTOC_TEPinScroll }, (void *) 0 },
    { { C_TEAutoView, PTOC_TEAutoView }, (void *) 0 },
    { { C_SetFractEnable, PTOC_SetFractEnable }, (void *) 0 },
    { { _SCSIDispatch, -1 }, (void *) 0 },
    { { _Pack8, -1 }, (void *) 0 },
    { { C_CopyMask, PTOC_CopyMask }, (void *) 0 },
    { { C_FixAtan2, PTOC_FixAtan2 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_HOpenResFile, PTOC_HOpenResFile }, (void *) 0 },
    { { C_HCreateResFile, PTOC_HCreateResFile }, (void *) 0 },
    { { C_Count1Types, PTOC_Count1Types }, (void *) 0 },
    { { C_InvalMenuBar, PTOC_InvalMenuBar }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_Get1Resource, PTOC_Get1Resource }, (void *) 0 },
    { { C_Get1NamedResource, PTOC_Get1NamedResource }, (void *) 0 },
    { { C_MaxSizeRsrc, PTOC_MaxSizeRsrc }, (void *) 0 },
    { { _ResourceDispatch, -1 }, (void *) 0 },
    { { _AliasDispatch,  -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_InsMenuItem, PTOC_InsMenuItem }, (void *) 0 },
    { { C_HideDItem, PTOC_HideDItem }, (void *) 0 },
    { { C_ShowDItem, PTOC_ShowDItem }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_Pack9, PTOC_Pack9 }, (void *) 0 },
    { { C_Pack10, PTOC_Pack10 }, (void *) 0 },
    { { _Pack11, -1 }, (void *) 0 },
    { { _Pack12, -1 }, (void *) 0 },
    { { C_Pack13, PTOC_Pack13 }, (void *) 0 },
    { { _Pack14, -1 }, (void *) 0 },
    { { _Pack15, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_SetFScaleDisable, PTOC_SetFScaleDisable }, (void *) 0 },
    { { C_FontMetrics, PTOC_FontMetrics }, (void *) 0 },
    { { _GetMaskTable, -1 }, (void *) 0 },
    { { C_MeasureText, PTOC_MeasureText }, (void *) 0 },
    { { C_CalcMask, PTOC_CalcMask }, (void *) 0 },
    { { C_SeedFill, PTOC_SeedFill }, (void *) 0 },
    { { C_ZoomWindow, PTOC_ZoomWindow }, (void *) 0 },
    { { C_TrackBox, PTOC_TrackBox }, (void *) 0 },
    { { C_TEGetOffset, PTOC_TEGetOffset }, (void *) 0 },
    { { _TEDispatch, -1 }, (void *) 0 },
    { { C_TEStylNew, PTOC_TEStylNew }, (void *) 0 },
    { { C_Long2Fix, PTOC_Long2Fix }, (void *) 0 },
    { { C_Fix2Long, PTOC_Fix2Long }, (void *) 0 },
    { { C_Fix2Frac, PTOC_Fix2Frac }, (void *) 0 },
    { { C_Frac2Fix, PTOC_Frac2Fix }, (void *) 0 },
    { { _Fix2X, -1 }, (void *) 0 },
    { { C_R_X2Fix, PTOC_R_X2Fix }, (void *) 0 },
    { { _Frac2X, -1 }, (void *) 0 },
    { { C_R_X2Frac, PTOC_R_X2Frac }, (void *) 0 },
    { { C_FracCos, PTOC_FracCos }, (void *) 0 },
    { { C_FracSin, PTOC_FracSin }, (void *) 0 },
    { { C_FracSqrt, PTOC_FracSqrt }, (void *) 0 },
    { { C_FracMul, PTOC_FracMul }, (void *) 0 },
    { { C_FracDiv, PTOC_FracDiv }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_FixDiv, PTOC_FixDiv }, (void *) 0 },
    { { C_GetItemCmd, PTOC_GetItemCmd }, (void *) 0 },
    { { C_SetItemCmd, PTOC_SetItemCmd }, (void *) 0 },
    { { C_InitCursor, PTOC_InitCursor }, (void *) 0 },
    { { C_SetCursor, PTOC_SetCursor }, (void *) 0 },
    { { C_HideCursor, PTOC_HideCursor }, (void *) 0 },
    { { C_ShowCursor, PTOC_ShowCursor }, (void *) 0 },
    { { _FontDispatch, -1 }, (void *) 0 },
    { { C_ShieldCursor, PTOC_ShieldCursor }, (void *) 0 },
    { { C_ObscureCursor, PTOC_ObscureCursor }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_BitAnd, PTOC_BitAnd }, (void *) 0 },
    { { C_BitXor, PTOC_BitXor }, (void *) 0 },
    { { C_BitNot, PTOC_BitNot }, (void *) 0 },
    { { C_BitOr, PTOC_BitOr }, (void *) 0 },
    { { C_BitShift, PTOC_BitShift }, (void *) 0 },
    { { C_BitTst, PTOC_BitTst }, (void *) 0 },
    { { C_BitSet, PTOC_BitSet }, (void *) 0 },
    { { C_BitClr, PTOC_BitClr }, (void *) 0 },
    { { C_WaitNextEvent, PTOC_WaitNextEvent }, (void *) 0 },
    { { C_Random, PTOC_Random }, (void *) 0 },
    { { C_ForeColor, PTOC_ForeColor }, (void *) 0 },
    { { C_BackColor, PTOC_BackColor }, (void *) 0 },
    { { C_ColorBit, PTOC_ColorBit }, (void *) 0 },
    { { C_GetPixel, PTOC_GetPixel }, (void *) 0 },
    { { C_StuffHex, PTOC_StuffHex }, (void *) 0 },
    { { C_LongMul, PTOC_LongMul }, (void *) 0 },
    { { C_FixMul, PTOC_FixMul }, (void *) 0 },
    { { C_FixRatio, PTOC_FixRatio }, (void *) 0 },
    { { C_HiWord, PTOC_HiWord }, (void *) 0 },
    { { C_LoWord, PTOC_LoWord }, (void *) 0 },
    { { C_FixRound, PTOC_FixRound }, (void *) 0 },
    { { C_InitPort, PTOC_InitPort }, (void *) 0 },
    { { C_InitGraf, PTOC_InitGraf }, (void *) 0 },
    { { C_OpenPort, PTOC_OpenPort }, (void *) 0 },
    { { C_LocalToGlobal, PTOC_LocalToGlobal }, (void *) 0 },
    { { C_GlobalToLocal, PTOC_GlobalToLocal }, (void *) 0 },
    { { C_GrafDevice, PTOC_GrafDevice }, (void *) 0 },
    { { C_SetPort, PTOC_SetPort }, (void *) 0 },
    { { C_GetPort, PTOC_GetPort }, (void *) 0 },
    { { C_SetPortBits, PTOC_SetPortBits }, (void *) 0 },
    { { C_PortSize, PTOC_PortSize }, (void *) 0 },
    { { C_MovePortTo, PTOC_MovePortTo }, (void *) 0 },
    { { C_SetOrigin, PTOC_SetOrigin }, (void *) 0 },
    { { C_SetClip, PTOC_SetClip }, (void *) 0 },
    { { C_GetClip, PTOC_GetClip }, (void *) 0 },
    { { C_ClipRect, PTOC_ClipRect }, (void *) 0 },
    { { C_BackPat, PTOC_BackPat }, (void *) 0 },
    { { C_ClosePort, PTOC_ClosePort }, (void *) 0 },
    { { C_AddPt, PTOC_AddPt }, (void *) 0 },
    { { C_SubPt, PTOC_SubPt }, (void *) 0 },
    { { C_SetPt, PTOC_SetPt }, (void *) 0 },
    { { C_EqualPt, PTOC_EqualPt }, (void *) 0 },
    { { C_StdText, PTOC_StdText }, (void *) 0 },
    { { C_DrawChar, PTOC_DrawChar }, (void *) 0 },
    { { C_DrawString, PTOC_DrawString }, (void *) 0 },
    { { C_DrawText, PTOC_DrawText }, (void *) 0 },
    { { C_TextWidth, PTOC_TextWidth }, (void *) 0 },
    { { C_TextFont, PTOC_TextFont }, (void *) 0 },
    { { C_TextFace, PTOC_TextFace }, (void *) 0 },
    { { C_TextMode, PTOC_TextMode }, (void *) 0 },
    { { C_TextSize, PTOC_TextSize }, (void *) 0 },
    { { C_GetFontInfo, PTOC_GetFontInfo }, (void *) 0 },
    { { C_StringWidth, PTOC_StringWidth }, (void *) 0 },
    { { C_CharWidth, PTOC_CharWidth }, (void *) 0 },
    { { C_SpaceExtra, PTOC_SpaceExtra }, (void *) 0 },
    { { _OSDispatch, -1 }, (void *) 0 },
    { { C_StdLine, PTOC_StdLine }, (void *) 0 },
    { { C_LineTo, PTOC_LineTo }, (void *) 0 },
    { { C_Line, PTOC_Line }, (void *) 0 },
    { { C_MoveTo, PTOC_MoveTo }, (void *) 0 },
    { { C_Move, PTOC_Move }, (void *) 0 },
    { { _ShutDown, -1 }, (void *) 0 },
    { { C_HidePen, PTOC_HidePen }, (void *) 0 },
    { { C_ShowPen, PTOC_ShowPen }, (void *) 0 },
    { { C_GetPenState, PTOC_GetPenState }, (void *) 0 },
    { { C_SetPenState, PTOC_SetPenState }, (void *) 0 },
    { { C_GetPen, PTOC_GetPen }, (void *) 0 },
    { { C_PenSize, PTOC_PenSize }, (void *) 0 },
    { { C_PenMode, PTOC_PenMode }, (void *) 0 },
    { { C_PenPat, PTOC_PenPat }, (void *) 0 },
    { { C_PenNormal, PTOC_PenNormal }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_StdRect, PTOC_StdRect }, (void *) 0 },
    { { C_FrameRect, PTOC_FrameRect }, (void *) 0 },
    { { C_PaintRect, PTOC_PaintRect }, (void *) 0 },
    { { C_EraseRect, PTOC_EraseRect }, (void *) 0 },
    { { C_InvertRect, PTOC_InvertRect }, (void *) 0 },
    { { C_FillRect, PTOC_FillRect }, (void *) 0 },
    { { C_EqualRect, PTOC_EqualRect }, (void *) 0 },
    { { C_SetRect, PTOC_SetRect }, (void *) 0 },
    { { C_OffsetRect, PTOC_OffsetRect }, (void *) 0 },
    { { C_InsetRect, PTOC_InsetRect }, (void *) 0 },
    { { C_SectRect, PTOC_SectRect }, (void *) 0 },
    { { C_UnionRect, PTOC_UnionRect }, (void *) 0 },
    { { C_Pt2Rect, PTOC_Pt2Rect }, (void *) 0 },
    { { C_PtInRect, PTOC_PtInRect }, (void *) 0 },
    { { C_EmptyRect, PTOC_EmptyRect }, (void *) 0 },
    { { C_StdRRect, PTOC_StdRRect }, (void *) 0 },
    { { C_FrameRoundRect, PTOC_FrameRoundRect }, (void *) 0 },
    { { C_PaintRoundRect, PTOC_PaintRoundRect }, (void *) 0 },
    { { C_EraseRoundRect, PTOC_EraseRoundRect }, (void *) 0 },
    { { C_InvertRoundRect, PTOC_InvertRoundRect }, (void *) 0 },
    { { C_FillRoundRect, PTOC_FillRoundRect }, (void *) 0 },
    { { _ScriptUtil, -1 }, (void *) 0 },
    { { C_StdOval, PTOC_StdOval }, (void *) 0 },
    { { C_FrameOval, PTOC_FrameOval }, (void *) 0 },
    { { C_PaintOval, PTOC_PaintOval }, (void *) 0 },
    { { C_EraseOval, PTOC_EraseOval }, (void *) 0 },
    { { C_InvertOval, PTOC_InvertOval }, (void *) 0 },
    { { C_FillOval, PTOC_FillOval }, (void *) 0 },
    { { C_SlopeFromAngle, PTOC_SlopeFromAngle }, (void *) 0 },
    { { C_StdArc, PTOC_StdArc }, (void *) 0 },
    { { C_FrameArc, PTOC_FrameArc }, (void *) 0 },
    { { C_PaintArc, PTOC_PaintArc }, (void *) 0 },
    { { C_EraseArc, PTOC_EraseArc }, (void *) 0 },
    { { C_InvertArc, PTOC_InvertArc }, (void *) 0 },
    { { C_FillArc, PTOC_FillArc }, (void *) 0 },
    { { C_PtToAngle, PTOC_PtToAngle }, (void *) 0 },
    { { C_AngleFromSlope, PTOC_AngleFromSlope }, (void *) 0 },
    { { C_StdPoly, PTOC_StdPoly }, (void *) 0 },
    { { C_FramePoly, PTOC_FramePoly }, (void *) 0 },
    { { C_PaintPoly, PTOC_PaintPoly }, (void *) 0 },
    { { C_ErasePoly, PTOC_ErasePoly }, (void *) 0 },
    { { C_InvertPoly, PTOC_InvertPoly }, (void *) 0 },
    { { C_FillPoly, PTOC_FillPoly }, (void *) 0 },
    { { C_OpenPoly, PTOC_OpenPoly }, (void *) 0 },
    { { C_ClosePoly, PTOC_ClosePoly }, (void *) 0 },
    { { C_KillPoly, PTOC_KillPoly }, (void *) 0 },
    { { C_OffsetPoly, PTOC_OffsetPoly }, (void *) 0 },
    { { C_PackBits, PTOC_PackBits }, (void *) 0 },
    { { C_UnpackBits, PTOC_UnpackBits }, (void *) 0 },
    { { C_StdRgn, PTOC_StdRgn }, (void *) 0 },
    { { C_FrameRgn, PTOC_FrameRgn }, (void *) 0 },
    { { C_PaintRgn, PTOC_PaintRgn }, (void *) 0 },
    { { C_EraseRgn, PTOC_EraseRgn }, (void *) 0 },
    { { C_InvertRgn, PTOC_InvertRgn }, (void *) 0 },
    { { C_FillRgn, PTOC_FillRgn }, (void *) 0 },
    { { C_BitMapToRegion, PTOC_BitMapToRegion }, (void *) 0 },
    { { C_NewRgn, PTOC_NewRgn }, (void *) 0 },
    { { C_DisposeRgn, PTOC_DisposeRgn }, (void *) 0 },
    { { C_OpenRgn, PTOC_OpenRgn }, (void *) 0 },
    { { C_CloseRgn, PTOC_CloseRgn }, (void *) 0 },
    { { C_CopyRgn, PTOC_CopyRgn }, (void *) 0 },
    { { C_SetEmptyRgn, PTOC_SetEmptyRgn }, (void *) 0 },
    { { C_SetRectRgn, PTOC_SetRectRgn }, (void *) 0 },
    { { C_RectRgn, PTOC_RectRgn }, (void *) 0 },
    { { C_OffsetRgn, PTOC_OffsetRgn }, (void *) 0 },
    { { C_InsetRgn, PTOC_InsetRgn }, (void *) 0 },
    { { C_EmptyRgn, PTOC_EmptyRgn }, (void *) 0 },
    { { C_EqualRgn, PTOC_EqualRgn }, (void *) 0 },
    { { C_SectRgn, PTOC_SectRgn }, (void *) 0 },
    { { C_UnionRgn, PTOC_UnionRgn }, (void *) 0 },
    { { C_DiffRgn, PTOC_DiffRgn }, (void *) 0 },
    { { C_XorRgn, PTOC_XorRgn }, (void *) 0 },
    { { C_PtInRgn, PTOC_PtInRgn }, (void *) 0 },
    { { C_RectInRgn, PTOC_RectInRgn }, (void *) 0 },
    { { C_SetStdProcs, PTOC_SetStdProcs }, (void *) 0 },
    { { C_StdBits, PTOC_StdBits }, (void *) 0 },
    { { C_CopyBits, PTOC_CopyBits }, (void *) 0 },
    { { C_StdTxMeas, PTOC_StdTxMeas }, (void *) 0 },
    { { C_StdGetPic, PTOC_StdGetPic }, (void *) 0 },
    { { C_ScrollRect, PTOC_ScrollRect }, (void *) 0 },
    { { C_StdPutPic, PTOC_StdPutPic }, (void *) 0 },
    { { C_StdComment, PTOC_StdComment }, (void *) 0 },
    { { C_PicComment, PTOC_PicComment }, (void *) 0 },
    { { C_OpenPicture, PTOC_OpenPicture }, (void *) 0 },
    { { C_ClosePicture, PTOC_ClosePicture }, (void *) 0 },
    { { C_KillPicture, PTOC_KillPicture }, (void *) 0 },
    { { C_DrawPicture, PTOC_DrawPicture }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_ScalePt, PTOC_ScalePt }, (void *) 0 },
    { { C_MapPt, PTOC_MapPt }, (void *) 0 },
    { { C_MapRect, PTOC_MapRect }, (void *) 0 },
    { { C_MapRgn, PTOC_MapRgn }, (void *) 0 },
    { { C_MapPoly, PTOC_MapPoly }, (void *) 0 },
    { { _PrGlue, -1 }, (void *) 0 },
    { { C_InitFonts, PTOC_InitFonts }, (void *) 0 },
    { { C_GetFontName, PTOC_GetFontName }, (void *) 0 },
    { { C_GetFNum, PTOC_GetFNum }, (void *) 0 },
    { { C_FMSwapFont, PTOC_FMSwapFont }, (void *) 0 },
    { { C_RealFont, PTOC_RealFont }, (void *) 0 },
    { { C_SetFontLock, PTOC_SetFontLock }, (void *) 0 },
    { { C_DrawGrowIcon, PTOC_DrawGrowIcon }, (void *) 0 },
    { { C_DragGrayRgn, PTOC_DragGrayRgn }, (void *) 0 },
    { { C_NewString, PTOC_NewString }, (void *) 0 },
    { { C_SetString, PTOC_SetString }, (void *) 0 },
    { { C_ShowHide, PTOC_ShowHide }, (void *) 0 },
    { { C_CalcVis, PTOC_CalcVis }, (void *) 0 },
    { { C_CalcVisBehind, PTOC_CalcVisBehind }, (void *) 0 },
    { { C_ClipAbove, PTOC_ClipAbove }, (void *) 0 },
    { { C_PaintOne, PTOC_PaintOne }, (void *) 0 },
    { { C_PaintBehind, PTOC_PaintBehind }, (void *) 0 },
    { { C_SaveOld, PTOC_SaveOld }, (void *) 0 },
    { { C_DrawNew, PTOC_DrawNew }, (void *) 0 },
    { { C_GetWMgrPort, PTOC_GetWMgrPort }, (void *) 0 },
    { { C_CheckUpdate, PTOC_CheckUpdate }, (void *) 0 },
    { { C_InitWindows, PTOC_InitWindows }, (void *) 0 },
    { { C_NewWindow, PTOC_NewWindow }, (void *) 0 },
    { { C_DisposeWindow, PTOC_DisposeWindow }, (void *) 0 },
    { { C_ShowWindow, PTOC_ShowWindow }, (void *) 0 },
    { { C_HideWindow, PTOC_HideWindow }, (void *) 0 },
    { { C_GetWRefCon, PTOC_GetWRefCon }, (void *) 0 },
    { { C_SetWRefCon, PTOC_SetWRefCon }, (void *) 0 },
    { { C_GetWTitle, PTOC_GetWTitle }, (void *) 0 },
    { { C_SetWTitle, PTOC_SetWTitle }, (void *) 0 },
    { { C_MoveWindow, PTOC_MoveWindow }, (void *) 0 },
    { { C_HiliteWindow, PTOC_HiliteWindow }, (void *) 0 },
    { { C_SizeWindow, PTOC_SizeWindow }, (void *) 0 },
    { { C_TrackGoAway, PTOC_TrackGoAway }, (void *) 0 },
    { { C_SelectWindow, PTOC_SelectWindow }, (void *) 0 },
    { { C_BringToFront, PTOC_BringToFront }, (void *) 0 },
    { { C_SendBehind, PTOC_SendBehind }, (void *) 0 },
    { { C_BeginUpdate, PTOC_BeginUpdate }, (void *) 0 },
    { { C_EndUpdate, PTOC_EndUpdate }, (void *) 0 },
    { { C_FrontWindow, PTOC_FrontWindow }, (void *) 0 },
    { { C_DragWindow, PTOC_DragWindow }, (void *) 0 },
    { { C_DragTheRgn, PTOC_DragTheRgn }, (void *) 0 },
    { { C_InvalRgn, PTOC_InvalRgn }, (void *) 0 },
    { { C_InvalRect, PTOC_InvalRect }, (void *) 0 },
    { { C_ValidRgn, PTOC_ValidRgn }, (void *) 0 },
    { { C_ValidRect, PTOC_ValidRect }, (void *) 0 },
    { { C_GrowWindow, PTOC_GrowWindow }, (void *) 0 },
    { { C_FindWindow, PTOC_FindWindow }, (void *) 0 },
    { { C_CloseWindow, PTOC_CloseWindow }, (void *) 0 },
    { { C_SetWindowPic, PTOC_SetWindowPic }, (void *) 0 },
    { { C_GetWindowPic, PTOC_GetWindowPic }, (void *) 0 },
    { { C_InitMenus, PTOC_InitMenus }, (void *) 0 },
    { { C_NewMenu, PTOC_NewMenu }, (void *) 0 },
    { { C_DisposeMenu, PTOC_DisposeMenu }, (void *) 0 },
    { { C_AppendMenu, PTOC_AppendMenu }, (void *) 0 },
    { { C_ClearMenuBar, PTOC_ClearMenuBar }, (void *) 0 },
    { { C_InsertMenu, PTOC_InsertMenu }, (void *) 0 },
    { { C_DeleteMenu, PTOC_DeleteMenu }, (void *) 0 },
    { { C_DrawMenuBar, PTOC_DrawMenuBar }, (void *) 0 },
    { { C_HiliteMenu, PTOC_HiliteMenu }, (void *) 0 },
    { { C_EnableItem, PTOC_EnableItem }, (void *) 0 },
    { { C_DisableItem, PTOC_DisableItem }, (void *) 0 },
    { { C_GetMenuBar, PTOC_GetMenuBar }, (void *) 0 },
    { { C_SetMenuBar, PTOC_SetMenuBar }, (void *) 0 },
    { { C_MenuSelect, PTOC_MenuSelect }, (void *) 0 },
    { { C_MenuKey, PTOC_MenuKey }, (void *) 0 },
    { { C_GetItemIcon, PTOC_GetItemIcon }, (void *) 0 },
    { { C_SetItemIcon, PTOC_SetItemIcon }, (void *) 0 },
    { { C_GetItemStyle, PTOC_GetItemStyle }, (void *) 0 },
    { { C_SetItemStyle, PTOC_SetItemStyle }, (void *) 0 },
    { { C_GetItemMark, PTOC_GetItemMark }, (void *) 0 },
    { { C_SetItemMark, PTOC_SetItemMark }, (void *) 0 },
    { { C_CheckItem, PTOC_CheckItem }, (void *) 0 },
    { { C_GetItem, PTOC_GetItem }, (void *) 0 },
    { { C_SetItem, PTOC_SetItem }, (void *) 0 },
    { { C_CalcMenuSize, PTOC_CalcMenuSize }, (void *) 0 },
    { { C_GetMHandle, PTOC_GetMHandle }, (void *) 0 },
    { { C_SetMenuFlash, PTOC_SetMenuFlash }, (void *) 0 },
    { { C_PlotIcon, PTOC_PlotIcon }, (void *) 0 },
    { { C_FlashMenuBar, PTOC_FlashMenuBar }, (void *) 0 },
    { { C_AddResMenu, PTOC_AddResMenu }, (void *) 0 },
    { { C_PinRect, PTOC_PinRect }, (void *) 0 },
    { { C_DeltaPoint, PTOC_DeltaPoint }, (void *) 0 },
    { { C_CountMItems, PTOC_CountMItems }, (void *) 0 },
    { { C_InsertResMenu, PTOC_InsertResMenu }, (void *) 0 },
    { { C_DelMenuItem, PTOC_DelMenuItem }, (void *) 0 },
    { { C_UpdtControl, PTOC_UpdtControl }, (void *) 0 },
    { { C_NewControl, PTOC_NewControl }, (void *) 0 },
    { { C_DisposeControl, PTOC_DisposeControl }, (void *) 0 },
    { { C_KillControls, PTOC_KillControls }, (void *) 0 },
    { { C_ShowControl, PTOC_ShowControl }, (void *) 0 },
    { { C_HideControl, PTOC_HideControl }, (void *) 0 },
    { { C_MoveControl, PTOC_MoveControl }, (void *) 0 },
    { { C_GetCRefCon, PTOC_GetCRefCon }, (void *) 0 },
    { { C_SetCRefCon, PTOC_SetCRefCon }, (void *) 0 },
    { { C_SizeControl, PTOC_SizeControl }, (void *) 0 },
    { { C_HiliteControl, PTOC_HiliteControl }, (void *) 0 },
    { { C_GetCTitle, PTOC_GetCTitle }, (void *) 0 },
    { { C_SetCTitle, PTOC_SetCTitle }, (void *) 0 },
    { { C_GetCtlValue, PTOC_GetCtlValue }, (void *) 0 },
    { { C_GetCtlMin, PTOC_GetCtlMin }, (void *) 0 },
    { { C_GetCtlMax, PTOC_GetCtlMax }, (void *) 0 },
    { { C_SetCtlValue, PTOC_SetCtlValue }, (void *) 0 },
    { { C_SetCtlMin, PTOC_SetCtlMin }, (void *) 0 },
    { { C_SetCtlMax, PTOC_SetCtlMax }, (void *) 0 },
    { { C_TestControl, PTOC_TestControl }, (void *) 0 },
    { { C_DragControl, PTOC_DragControl }, (void *) 0 },
    { { C_TrackControl, PTOC_TrackControl }, (void *) 0 },
    { { C_DrawControls, PTOC_DrawControls }, (void *) 0 },
    { { C_GetCtlAction, PTOC_GetCtlAction }, (void *) 0 },
    { { C_SetCtlAction, PTOC_SetCtlAction }, (void *) 0 },
    { { C_FindControl, PTOC_FindControl }, (void *) 0 },
    { { C_Draw1Control, PTOC_Draw1Control }, (void *) 0 },
    { { _Dequeue, -1 }, (void *) 0 },
    { { _Enqueue, -1 }, (void *) 0 },
    { { C_GetNextEvent, PTOC_GetNextEvent }, (void *) 0 },
    { { C_EventAvail, PTOC_EventAvail }, (void *) 0 },
    { { C_GetMouse, PTOC_GetMouse }, (void *) 0 },
    { { C_StillDown, PTOC_StillDown }, (void *) 0 },
    { { C_Button, PTOC_Button }, (void *) 0 },
    { { C_TickCount, PTOC_TickCount }, (void *) 0 },
    { { C_GetKeys, PTOC_GetKeys }, (void *) 0 },
    { { C_WaitMouseUp, PTOC_WaitMouseUp }, (void *) 0 },
    { { C_UpdtDialog, PTOC_UpdtDialog }, (void *) 0 },
    { { C_CouldDialog, PTOC_CouldDialog }, (void *) 0 },
    { { C_FreeDialog, PTOC_FreeDialog }, (void *) 0 },
    { { C_InitDialogs, PTOC_InitDialogs }, (void *) 0 },
    { { C_GetNewDialog, PTOC_GetNewDialog }, (void *) 0 },
    { { C_NewDialog, PTOC_NewDialog }, (void *) 0 },
    { { C_SelIText, PTOC_SelIText }, (void *) 0 },
    { { C_IsDialogEvent, PTOC_IsDialogEvent }, (void *) 0 },
    { { C_DialogSelect, PTOC_DialogSelect }, (void *) 0 },
    { { C_DrawDialog, PTOC_DrawDialog }, (void *) 0 },
    { { C_CloseDialog, PTOC_CloseDialog }, (void *) 0 },
    { { C_DisposDialog, PTOC_DisposDialog }, (void *) 0 },
    { { C_FindDItem, PTOC_FindDItem }, (void *) 0 },
    { { C_Alert, PTOC_Alert }, (void *) 0 },
    { { C_StopAlert, PTOC_StopAlert }, (void *) 0 },
    { { C_NoteAlert, PTOC_NoteAlert }, (void *) 0 },
    { { C_CautionAlert, PTOC_CautionAlert }, (void *) 0 },
    { { C_CouldAlert, PTOC_CouldAlert }, (void *) 0 },
    { { C_FreeAlert, PTOC_FreeAlert }, (void *) 0 },
    { { C_ParamText, PTOC_ParamText }, (void *) 0 },
    { { C_ErrorSound, PTOC_ErrorSound }, (void *) 0 },
    { { C_GetDItem, PTOC_GetDItem }, (void *) 0 },
    { { C_SetDItem, PTOC_SetDItem }, (void *) 0 },
    { { C_SetIText, PTOC_SetIText }, (void *) 0 },
    { { C_GetIText, PTOC_GetIText }, (void *) 0 },
    { { C_ModalDialog, PTOC_ModalDialog }, (void *) 0 },
    { { C_DetachResource, PTOC_DetachResource }, (void *) 0 },
    { { C_SetResPurge, PTOC_SetResPurge }, (void *) 0 },
    { { C_CurResFile, PTOC_CurResFile }, (void *) 0 },
    { { C_InitResources, PTOC_InitResources }, (void *) 0 },
    { { C_RsrcZoneInit, PTOC_RsrcZoneInit }, (void *) 0 },
    { { C_OpenResFile, PTOC_OpenResFile }, (void *) 0 },
    { { C_UseResFile, PTOC_UseResFile }, (void *) 0 },
    { { C_UpdateResFile, PTOC_UpdateResFile }, (void *) 0 },
    { { C_CloseResFile, PTOC_CloseResFile }, (void *) 0 },
    { { C_SetResLoad, PTOC_SetResLoad }, (void *) 0 },
    { { C_CountResources, PTOC_CountResources }, (void *) 0 },
    { { C_GetIndResource, PTOC_GetIndResource }, (void *) 0 },
    { { C_CountTypes, PTOC_CountTypes }, (void *) 0 },
    { { C_GetIndType, PTOC_GetIndType }, (void *) 0 },
    { { __GetResource, -1 }, (void *) 0 },
    { { C_GetNamedResource, PTOC_GetNamedResource }, (void *) 0 },
    { { C_LoadResource, PTOC_LoadResource }, (void *) 0 },
    { { C_ReleaseResource, PTOC_ReleaseResource }, (void *) 0 },
    { { C_HomeResFile, PTOC_HomeResFile }, (void *) 0 },
    { { C_SizeResource, PTOC_SizeResource }, (void *) 0 },
    { { C_GetResAttrs, PTOC_GetResAttrs }, (void *) 0 },
    { { C_SetResAttrs, PTOC_SetResAttrs }, (void *) 0 },
    { { C_GetResInfo, PTOC_GetResInfo }, (void *) 0 },
    { { C_SetResInfo, PTOC_SetResInfo }, (void *) 0 },
    { { C_ChangedResource, PTOC_ChangedResource }, (void *) 0 },
    { { C_AddResource, PTOC_AddResource }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_RmveResource, PTOC_RmveResource }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_ResError, PTOC_ResError }, (void *) 0 },
    { { C_WriteResource, PTOC_WriteResource }, (void *) 0 },
    { { C_CreateResFile, PTOC_CreateResFile }, (void *) 0 },
    { { C_SystemEvent, PTOC_SystemEvent }, (void *) 0 },
    { { C_SystemClick, PTOC_SystemClick }, (void *) 0 },
    { { C_SystemTask, PTOC_SystemTask }, (void *) 0 },
    { { C_SystemMenu, PTOC_SystemMenu }, (void *) 0 },
    { { C_OpenDeskAcc, PTOC_OpenDeskAcc }, (void *) 0 },
    { { C_CloseDeskAcc, PTOC_CloseDeskAcc }, (void *) 0 },
    { { C_GetPattern, PTOC_GetPattern }, (void *) 0 },
    { { C_GetCursor, PTOC_GetCursor }, (void *) 0 },
    { { C_GetString, PTOC_GetString }, (void *) 0 },
    { { C_GetIcon, PTOC_GetIcon }, (void *) 0 },
    { { C_GetPicture, PTOC_GetPicture }, (void *) 0 },
    { { C_GetNewWindow, PTOC_GetNewWindow }, (void *) 0 },
    { { C_GetNewControl, PTOC_GetNewControl }, (void *) 0 },
    { { C_GetMenu, PTOC_GetMenu }, (void *) 0 },
    { { C_GetNewMBar, PTOC_GetNewMBar }, (void *) 0 },
    { { C_UniqueID, PTOC_UniqueID }, (void *) 0 },
    { { C_SystemEdit, PTOC_SystemEdit }, (void *) 0 },
    { { C_KeyTrans, PTOC_KeyTrans }, (void *) 0 },
    { { C_OpenRFPerm, PTOC_OpenRFPerm }, (void *) 0 },
    { { C_RsrcMapEntry, PTOC_RsrcMapEntry }, (void *) 0 },
    { { _Secs2Date, -1 }, (void *) 0 },
    { { _Date2Secs, -1 }, (void *) 0 },
    { { C_SysBeep, PTOC_SysBeep }, (void *) 0 },
    { { C_SysError, PTOC_SysError }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_TEGetText, PTOC_TEGetText }, (void *) 0 },
    { { C_TEInit, PTOC_TEInit }, (void *) 0 },
    { { C_TEDispose, PTOC_TEDispose }, (void *) 0 },
    { { C_TextBox, PTOC_TextBox }, (void *) 0 },
    { { C_TESetText, PTOC_TESetText }, (void *) 0 },
    { { C_TECalText, PTOC_TECalText }, (void *) 0 },
    { { C_TESetSelect, PTOC_TESetSelect }, (void *) 0 },
    { { C_TENew, PTOC_TENew }, (void *) 0 },
    { { C_TEUpdate, PTOC_TEUpdate }, (void *) 0 },
    { { C_TEClick, PTOC_TEClick }, (void *) 0 },
    { { C_TECopy, PTOC_TECopy }, (void *) 0 },
    { { C_TECut, PTOC_TECut }, (void *) 0 },
    { { C_TEDelete, PTOC_TEDelete }, (void *) 0 },
    { { C_TEActivate, PTOC_TEActivate }, (void *) 0 },
    { { C_TEDeactivate, PTOC_TEDeactivate }, (void *) 0 },
    { { C_TEIdle, PTOC_TEIdle }, (void *) 0 },
    { { C_TEPaste, PTOC_TEPaste }, (void *) 0 },
    { { C_TEKey, PTOC_TEKey }, (void *) 0 },
    { { C_TEScroll, PTOC_TEScroll }, (void *) 0 },
    { { C_TEInsert, PTOC_TEInsert }, (void *) 0 },
    { { C_TESetJust, PTOC_TESetJust }, (void *) 0 },
    { { C_Munger, PTOC_Munger }, (void *) 0 },
    { { _HandToHand, -1 }, (void *) 0 },
    { { _PtrToXHand, -1 }, (void *) 0 },
    { { _PtrToHand, -1 }, (void *) 0 },
    { { _HandAndHand, -1 }, (void *) 0 },
    { { C_InitPack, PTOC_InitPack }, (void *) 0 },
    { { C_InitAllPacks, PTOC_InitAllPacks }, (void *) 0 },
    { { _Pack0, -1 }, (void *) 0 },
    { { C_Pack1, PTOC_Pack1 }, (void *) 0 },
    { { _Pack2, -1 }, (void *) 0 },
    { { _Pack3, -1 }, (void *) 0 },
    { { _Pack4, -1 }, (void *) 0 },
    { { _Pack5, -1 }, (void *) 0 },
    { { _Pack6, -1 }, (void *) 0 },
    { { _Pack7, -1 }, (void *) 0 },
    { { _PtrAndHand, -1 }, (void *) 0 },
    { { _LoadSeg, -1 }, (void *) 0 },
    { { C_UnloadSeg, PTOC_UnloadSeg }, (void *) 0 },
    { { _Launch, -1 }, (void *) 0 },
    { { _Chain, -1 }, (void *) 0 },
    { { C_ExitToShell, PTOC_ExitToShell }, (void *) 0 },
    { { C_GetAppParms, PTOC_GetAppParms }, (void *) 0 },
    { { C_GetResFileAttrs, PTOC_GetResFileAttrs }, (void *) 0 },
    { { C_SetResFileAttrs, PTOC_SetResFileAttrs }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_InfoScrap, PTOC_InfoScrap }, (void *) 0 },
    { { C_UnloadScrap, PTOC_UnloadScrap }, (void *) 0 },
    { { C_LoadScrap, PTOC_LoadScrap }, (void *) 0 },
    { { C_ZeroScrap, PTOC_ZeroScrap }, (void *) 0 },
    { { C_GetScrap, PTOC_GetScrap }, (void *) 0 },
    { { C_PutScrap, PTOC_PutScrap }, (void *) 0 },
    { { _Debugger, -1 }, (void *) 0 },
    { { C_OpenCPort, PTOC_OpenCPort }, (void *) 0 },
    { { C_InitCPort, PTOC_InitCPort }, (void *) 0 },
    { { C_CloseCPort, PTOC_CloseCPort }, (void *) 0 },
    { { C_NewPixMap, PTOC_NewPixMap }, (void *) 0 },
    { { C_DisposPixMap, PTOC_DisposPixMap }, (void *) 0 },
    { { C_CopyPixMap, PTOC_CopyPixMap }, (void *) 0 },
    { { C_SetPortPix, PTOC_SetPortPix }, (void *) 0 },
    { { C_NewPixPat, PTOC_NewPixPat }, (void *) 0 },
    { { C_DisposPixPat, PTOC_DisposPixPat }, (void *) 0 },
    { { C_CopyPixPat, PTOC_CopyPixPat }, (void *) 0 },
    { { C_PenPixPat, PTOC_PenPixPat }, (void *) 0 },
    { { C_BackPixPat, PTOC_BackPixPat }, (void *) 0 },
    { { C_GetPixPat, PTOC_GetPixPat }, (void *) 0 },
    { { C_MakeRGBPat, PTOC_MakeRGBPat }, (void *) 0 },
    { { C_FillCRect, PTOC_FillCRect }, (void *) 0 },
    { { C_FillCOval, PTOC_FillCOval }, (void *) 0 },
    { { C_FillCRoundRect, PTOC_FillCRoundRect }, (void *) 0 },
    { { C_FillCArc, PTOC_FillCArc }, (void *) 0 },
    { { C_FillCRgn, PTOC_FillCRgn }, (void *) 0 },
    { { C_FillCPoly, PTOC_FillCPoly }, (void *) 0 },
    { { C_RGBForeColor, PTOC_RGBForeColor }, (void *) 0 },
    { { C_RGBBackColor, PTOC_RGBBackColor }, (void *) 0 },
    { { C_SetCPixel, PTOC_SetCPixel }, (void *) 0 },
    { { C_GetCPixel, PTOC_GetCPixel }, (void *) 0 },
    { { C_GetCTable, PTOC_GetCTable }, (void *) 0 },
    { { C_GetForeColor, PTOC_GetForeColor }, (void *) 0 },
    { { C_GetBackColor, PTOC_GetBackColor }, (void *) 0 },
    { { C_GetCCursor, PTOC_GetCCursor }, (void *) 0 },
    { { C_SetCCursor, PTOC_SetCCursor }, (void *) 0 },
    { { C_AllocCursor, PTOC_AllocCursor }, (void *) 0 },
    { { C_GetCIcon, PTOC_GetCIcon }, (void *) 0 },
    { { C_PlotCIcon, PTOC_PlotCIcon }, (void *) 0 },
    { { C_OpenCPicture, PTOC_OpenCPicture }, (void *) 0 },
    { { C_OpColor, PTOC_OpColor }, (void *) 0 },
    { { C_HiliteColor, PTOC_HiliteColor }, (void *) 0 },
    { { C_CharExtra, PTOC_CharExtra }, (void *) 0 },
    { { C_DisposCTable, PTOC_DisposCTable }, (void *) 0 },
    { { C_DisposeCIcon, PTOC_DisposeCIcon }, (void *) 0 },
    { { C_DisposCCursor, PTOC_DisposCCursor }, (void *) 0 },
    { { C_GetMaxDevice, PTOC_GetMaxDevice }, (void *) 0 },
    { { C_GetCTSeed, PTOC_GetCTSeed }, (void *) 0 },
    { { C_GetDeviceList, PTOC_GetDeviceList }, (void *) 0 },
    { { C_GetMainDevice, PTOC_GetMainDevice }, (void *) 0 },
    { { C_GetNextDevice, PTOC_GetNextDevice }, (void *) 0 },
    { { C_TestDeviceAttribute, PTOC_TestDeviceAttribute }, (void *) 0 },
    { { C_SetDeviceAttribute, PTOC_SetDeviceAttribute }, (void *) 0 },
    { { C_InitGDevice, PTOC_InitGDevice }, (void *) 0 },
    { { C_NewGDevice, PTOC_NewGDevice }, (void *) 0 },
    { { C_DisposGDevice, PTOC_DisposGDevice }, (void *) 0 },
    { { C_SetGDevice, PTOC_SetGDevice }, (void *) 0 },
    { { C_GetGDevice, PTOC_GetGDevice }, (void *) 0 },
    { { C_Color2Index, PTOC_Color2Index }, (void *) 0 },
    { { C_Index2Color, PTOC_Index2Color }, (void *) 0 },
    { { C_InvertColor, PTOC_InvertColor }, (void *) 0 },
    { { C_RealColor, PTOC_RealColor }, (void *) 0 },
    { { C_GetSubTable, PTOC_GetSubTable }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_MakeITable, PTOC_MakeITable }, (void *) 0 },
    { { C_AddSearch, PTOC_AddSearch }, (void *) 0 },
    { { C_AddComp, PTOC_AddComp }, (void *) 0 },
    { { C_SetClientID, PTOC_SetClientID }, (void *) 0 },
    { { C_ProtectEntry, PTOC_ProtectEntry }, (void *) 0 },
    { { C_ReserveEntry, PTOC_ReserveEntry }, (void *) 0 },
    { { C_SetEntries, PTOC_SetEntries }, (void *) 0 },
    { { C_QDError, PTOC_QDError }, (void *) 0 },
    { { C_SetWinColor, PTOC_SetWinColor }, (void *) 0 },
    { { C_GetAuxWin, PTOC_GetAuxWin }, (void *) 0 },
    { { C_SetCtlColor, PTOC_SetCtlColor }, (void *) 0 },
    { { C_GetAuxCtl, PTOC_GetAuxCtl }, (void *) 0 },
    { { C_NewCWindow, PTOC_NewCWindow }, (void *) 0 },
    { { C_GetNewCWindow, PTOC_GetNewCWindow }, (void *) 0 },
    { { C_SetDeskCPat, PTOC_SetDeskCPat }, (void *) 0 },
    { { C_GetCWMgrPort, PTOC_GetCWMgrPort }, (void *) 0 },
    { { C_SaveEntries, PTOC_SaveEntries }, (void *) 0 },
    { { C_RestoreEntries, PTOC_RestoreEntries }, (void *) 0 },
    { { C_NewCDialog, PTOC_NewCDialog }, (void *) 0 },
    { { C_DelSearch, PTOC_DelSearch }, (void *) 0 },
    { { C_DelComp, PTOC_DelComp }, (void *) 0 },
    { { C_SetStdCProcs, PTOC_SetStdCProcs }, (void *) 0 },
    { { C_CalcCMask, PTOC_CalcCMask }, (void *) 0 },
    { { C_SeedCFill, PTOC_SeedCFill }, (void *) 0 },
    { { C_IMVI_CopyDeepMask, PTOC_IMVI_CopyDeepMask }, (void *) 0 },
    { { _HighLevelFSDispatch, -1 }, (void *) 0 }, /* AA52 */
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
#if (!defined (powerpc) && !defined (__ppc__)) || defined (CFM_PROBLEMS)
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 }, /* AA5A */
#else
    { { _MixedMode, -1 }, (void *) 0 },
    { { _CodeFragment, -1 }, (void *) 0 }, /* AA5A */
#endif
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_DelMCEntries, PTOC_DelMCEntries }, (void *) 0 },
    { { C_GetMCInfo, PTOC_GetMCInfo }, (void *) 0 },
    { { C_SetMCInfo, PTOC_SetMCInfo }, (void *) 0 },
    { { C_DispMCInfo, PTOC_DispMCInfo }, (void *) 0 },
    { { C_GetMCEntry, PTOC_GetMCEntry }, (void *) 0 },
    { { C_SetMCEntries, PTOC_SetMCEntries }, (void *) 0 },
    { { C_MenuChoice, PTOC_MenuChoice }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _DialogDispatch, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { C_InitPalettes, PTOC_InitPalettes }, (void *) 0 },
    { { C_NewPalette, PTOC_NewPalette }, (void *) 0 },
    { { C_GetNewPalette, PTOC_GetNewPalette }, (void *) 0 },
    { { C_DisposePalette, PTOC_DisposePalette }, (void *) 0 },
    { { C_ActivatePalette, PTOC_ActivatePalette }, (void *) 0 },
    { { C_NSetPalette, PTOC_NSetPalette }, (void *) 0 },
    { { C_GetPalette, PTOC_GetPalette }, (void *) 0 },
    { { C_PmForeColor, PTOC_PmForeColor }, (void *) 0 },
    { { C_PmBackColor, PTOC_PmBackColor }, (void *) 0 },
    { { C_AnimateEntry, PTOC_AnimateEntry }, (void *) 0 },
    { { C_AnimatePalette, PTOC_AnimatePalette }, (void *) 0 },
    { { C_GetEntryColor, PTOC_GetEntryColor }, (void *) 0 },
    { { C_SetEntryColor, PTOC_SetEntryColor }, (void *) 0 },
    { { C_GetEntryUsage, PTOC_GetEntryUsage }, (void *) 0 },
    { { C_SetEntryUsage, PTOC_SetEntryUsage }, (void *) 0 },
    { { C_CTab2Palette, PTOC_CTab2Palette }, (void *) 0 },
    { { C_Palette2CTab, PTOC_Palette2CTab }, (void *) 0 },
    { { C_CopyPalette, PTOC_CopyPalette }, (void *) 0 },
    { { _PaletteDispatch, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _QuickTime, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
#if defined (powerpc) && !defined (__ppc__)
    { { _modeswitch, -1 }, (void *) 0 },
#else
    { { _Unimplemented, -1 }, (void *) 0 },
#endif
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _WackyQD32Trap, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _QDExtensions, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _IconDispatch, -1 }, (void *) 0 },
    { { C_DeviceLoop, PTOC_DeviceLoop }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _Unimplemented, -1 }, (void *) 0 },
    { { _DebugStr, -1 }, (void *) 0 },
};

toolstuff_t pstuff[] = {
    { {	C_ROMlib_mytrack,	PTOC_ROMlib_mytrack }, (void *) 0 },
    { { C_ROMlib_stdftrack,	PTOC_ROMlib_stdftrack }, (void *) 0 },
    { { C_ROMlib_myfilt,	PTOC_ROMlib_myfilt }, (void *) 0 },
    { { C_ROMlib_stdffilt,	PTOC_ROMlib_stdffilt }, (void *) 0 },
    { { C_ROMlib_numsonlyfilterproc,
   				PTOC_ROMlib_numsonlyfilterproc }, (void *) 0 },
    { { C_ROMlib_stlfilterproc,	PTOC_ROMlib_stlfilterproc }, (void *) 0 },

/* NOTE: the following four routines don't really use pascal calling
	 conventions, but we do need pstuff entries for them so we can
	 look for their addresses and short circuit calls to them.  The
	 zero is correct because they take no args and return no value */

    { { C_ROMlib_wakeup,	0 }, (void *) 0 },
    { { C_ROMlib_vcatch,	0 }, (void *) 0 },
    { {	C_ROMlib_dotext,	0 }, (void *) 0 },
    { { C_handle_refresh,       0 }, (void *) 0 },

    { { C_ROMlib_mysound,	PTOC_ROMlib_mysound }, (void *) 0 },
    { { C_ROMlib_myjobproc,	PTOC_ROMlib_myjobproc }, (void *) 0 },
    { { C_ROMlib_mystlproc,	PTOC_ROMlib_mystlproc }, (void *) 0 },

    { {	C_cdef0,		PTOC_cdef0 }, (void *) 0 },
    { { C_cdef16,		PTOC_cdef16 }, (void *) 0 },
    { { C_ldef0,		PTOC_ldef0 }, (void *) 0 },
    { { C_mdef0,		PTOC_mdef0 }, (void *) 0 },
    { { C_mbdf0,		PTOC_mbdf0 }, (void *) 0 },
    { {	C_wdef0,		PTOC_wdef0 }, (void *) 0 },
    { { C_wdef16,		PTOC_wdef16 }, (void *) 0 },
    { { C_snth5,		PTOC_snth5 }, (void *) 0 },

    { { C_IUMagString,		PTOC_IUMagString }, (void *) 0 },
    { { C_PrStlInit,		PTOC_PrStlInit }, (void *) 0 },
    { {	C_PrJobInit,		PTOC_PrJobInit }, (void *) 0 },

    { {	C_StdText,		PTOC_StdText }, (void *) 0 },
    { {	C_StdLine,		PTOC_StdLine }, (void *) 0 },
    { {	C_StdRect,		PTOC_StdRect }, (void *) 0 },
    { { C_StdOval,		PTOC_StdOval }, (void *) 0 },
    { {	C_StdRRect,		PTOC_StdRRect }, (void *) 0 },
    { {	C_StdArc,		PTOC_StdArc }, (void *) 0 },
    { { C_StdRgn,		PTOC_StdRgn }, (void *) 0 },
    { { C_StdPoly,		PTOC_StdPoly }, (void *) 0 },
    { {	C_StdBits,		PTOC_StdBits }, (void *) 0 },
    { { C_StdComment,		PTOC_StdComment }, (void *) 0 },
    { {	C_StdTxMeas,		PTOC_StdTxMeas }, (void *) 0 },
    { {	C_StdPutPic,		PTOC_StdPutPic }, (void *) 0 },

    { { C_FMSwapFont,		PTOC_FMSwapFont }, (void *) 0},
    { { C_InitCursor,		PTOC_InitCursor }, (void *) 0},

    { { C_textasPS,		PTOC_textasPS }, (void *) 0},
    { { C_PrText,		PTOC_PrText }, (void *) 0},
    { { C_PrLine,		PTOC_PrLine }, (void *) 0},
    { { C_PrRect,		PTOC_PrRect }, (void *) 0},
    { { C_PrRRect,		PTOC_PrRRect }, (void *) 0},
    { { C_PrOval,		PTOC_PrOval }, (void *) 0},
    { { C_PrArc,		PTOC_PrArc }, (void *) 0},
    { { C_PrPoly,		PTOC_PrPoly }, (void *) 0},
    { { C_PrRgn,		PTOC_PrRgn }, (void *) 0},
    { { C_PrBits,		PTOC_PrBits }, (void *) 0},
    { { C_PrComment,		PTOC_PrComment }, (void *) 0},
    { { C_PrTxMeas,		PTOC_PrTxMeas }, (void *) 0},
    { { C_PrGetPic,		PTOC_PrGetPic }, (void *) 0},
    { { C_PrPutPic,		PTOC_PrPutPic }, (void *) 0},
    { { C_donotPrText,		PTOC_donotPrText }, (void *) 0},
    { { C_donotPrLine,		PTOC_donotPrLine }, (void *) 0},
    { { C_donotPrRect,		PTOC_donotPrRect }, (void *) 0},
    { { C_donotPrRRect,		PTOC_donotPrRRect }, (void *) 0},
    { { C_donotPrOval,		PTOC_donotPrOval }, (void *) 0},
    { { C_donotPrArc,		PTOC_donotPrArc }, (void *) 0},
    { { C_donotPrPoly,		PTOC_donotPrPoly }, (void *) 0},
    { { C_donotPrRgn,		PTOC_donotPrRgn }, (void *) 0},
    { { C_donotPrBits,		PTOC_donotPrBits }, (void *) 0},
    { { C_donotPrGetPic,	PTOC_donotPrGetPic }, (void *) 0},
    { { C_donotPrPutPic,	PTOC_donotPrPutPic }, (void *) 0},
    { { C_ROMlib_filebox,	PTOC_ROMlib_filebox }, (void *) 0},
    { { C_StdGetPic,		PTOC_StdGetPic }, (void *) 0},

    { { _flushcache,		-1 }, (void *) 0},
    { { _Key1Trans,		-1 }, (void *) 0},
    { { _Key2Trans,		-1 }, (void *) 0},

    { { NULL /* was C_ROMlib_licensefilt */,	0 /* was PTOC_ROMlib_licensefilt */ }, (void *) 0 },
    { { C_unixmount,		PTOC_unixmount }, (void *) 0 },
    { { C_GestaltTablesOnly,	PTOC_GestaltTablesOnly }, (void *) 0 },
    { { C_sound_timer_handler,  0 }, (void *) 0 },
    { { C_adb_service_stub, 	0 }, (void *) 0 },
    { { C_cdef1008, 		PTOC_cdef1008 }, (void *) 0 },
    { { _bad_trap_unimplemented, -1 }, (void *) 0 },
    { { C_pack8_unknown_selector, PTOC_pack8_unknown_selector }, (void *) 0 },
    { { C_PhysicalGestalt,      PTOC_PhysicalGestalt }, (void *) 0 },

    { { C_HideCursor, PTOC_HideCursor }, (void *) 0 },
    { { C_ShowCursor, PTOC_ShowCursor }, (void *) 0 },
    { { C_ShieldCursor, PTOC_ShieldCursor }, (void *) 0 },
    { { C_SetCursor, PTOC_SetCursor }, (void *) 0 },
    { { C_ObscureCursor, PTOC_ObscureCursor }, (void *) 0 },
    { { C_unknown574, PTOC_ShowCursor }, (void *) 0 },

    { { C_ROMlib_circle_ok,	PTOC_ROMlib_circle_ok }, (void *) 0},
    { { C_ROMlib_orientation,	PTOC_ROMlib_orientation }, (void *) 0},

    { { C_new_draw_scroll,	PTOC_DeviceLoopDrawingProcTemplate }, (void *) 0},
    { { C_new_pos_ctl,		PTOC_DeviceLoopDrawingProcTemplate }, (void *) 0},
};

void *fsroutines[][2] = {
    { /* 0xA000 */  PBOpen,	PBHOpen		/*  0 */ },
#define OPENTRAP	0
#define OPENINDEX	0

    { /* 0xA001 */  PBClose,	PBClose		/*  1 */ },
#define CLOSETRAP	1
#define CLOSEINDEX	1

    { /* 0xA002 */  PBRead,	PBRead		/*  2 */ },
#define READTRAP	2
#define READINDEX	2

    { /* 0xA003 */  PBWrite,	PBWrite		/*  3 */ },
#define WRITETRAP	3
#define WRITEINDEX	3

    { /* 0xA004 */  PBControl,	PBControl	/*  4 */ },
#define CONTROLTRAP	4
#define CONTROLINDEX	4

    { /* 0xA005 */  PBStatus,	PBStatus	/*  5 */ },
#define STATUSTRAP	5
#define STATUSINDEX	5

    { /* 0xA006 */  PBKillIO,	PBKillIO	/*  6 */ },
#define KILLIOTRAP	6
#define KILLIOINDEX	6

    { /* 0xA007 */  PBGetVInfo,	PBHGetVInfo	/*  7 */ },
#define GETVINFOTRAP	7
#define GETVINFOINDEX	7

    { /* 0xA008 */  PBCreate,	PBHCreate	/*  8 */ },
#define CREATETRAP	8
#define CREATEINDEX	8

    { /* 0xA009 */  PBDelete,	PBHDelete	/*  9 */ },
#define DELETETRAP	9
#define DELETEINDEX	9

    { /* 0xA00A */  PBOpenRF,	PBHOpenRF	/* 10 */ },
#define OPENRFTRAP	0xA
#define OPENRFINDEX	10

    { /* 0xA00B */  PBRename,	PBHRename	/* 11 */ },
#define RENAMETRAP	0xB
#define RENAMEINDEX	11

    { /* 0xA00C */  PBGetFInfo,	PBHGetFInfo	/* 12 */ },
#define GETFINFOTRAP	0xC
#define GETFINFOINDEX	12

    { /* 0xA00D */  PBSetFInfo,	PBHSetFInfo	/* 13 */ },
#define SETFINFOTRAP	0xD
#define SETFINFOINDEX	13

    { /* 0xA00E */  PBUnmountVol,	PBUnmountVol	/* 14 */ },
#define UNMOUNTVOLTRAP	0xE
#define UNMOUNTVOLINDEX	14

    { /* 0xA00F */  PBMountVol,	PBMountVol	/* 15 */ },
#define MOUNTVOLTRAP	0xF
#define MOUNTVOLINDEX	15

    { /* 0xA010 */  PBAllocate,	PBAllocate	/* 16 */ },
#define ALLOCATETRAP	0x10
#define ALLOCATEINDEX	16

    { /* 0xA011 */  PBGetEOF,	PBGetEOF	/* 17 */ },
#define GETEOFTRAP	0x11
#define GETEOFINDEX	17

    { /* 0xA012 */  PBSetEOF,	PBSetEOF	/* 18 */ },
#define SETEOFTRAP	0x12
#define SETEOFINDEX	18

    { /* 0xA013 */  PBFlushVol,	PBFlushVol	/* 19 */ },
#define FLUSHVOLTRAP	0x13
#define FLUSHVOLINDEX	19

    { /* 0xA014 */  PBGetVol,	PBHGetVol	/* 20 */ },
#define GETVOLTRAP	0x14
#define GETVOLINDEX	20

    { /* 0xA015 */  PBSetVol,	PBHSetVol	/* 21 */ },
#define SETVOLTRAP	0x15
#define SETVOLINDEX	21

    { /* 0xA017 */  PBEject,	PBEject		/* 22 */ },
#define EJECTTRAP	0x17
#define EJECTINDEX	22

    { /* 0xA018 */  PBGetFPos,	PBGetFPos	/* 23 */ },
#define GETFPOSTRAP	0x18
#define GETFPOSINDEX	23

    { /* 0xA035 */  PBOffLine,	PBOffLine	/* 24 */ },
#define OFFLINETRAP	0x35
#define OFFLINEINDEX	24

    { /* 0xA041 */  PBSetFLock,	PBHSetFLock	/* 25 */ },
#define SETFLOCKTRAP	0x41
#define SETFLOCKINDEX	25

    { /* 0xA042 */  PBRstFLock,	PBHRstFLock	/* 26 */ },
#define RSTFLOCKTRAP	0x42
#define RSTFLOCKINDEX	26

    { /* 0xA043 */  PBSetFVers,	PBSetFVers	/* 27 */ },
#define SETFVERSTRAP	0x43
#define SETFVERSINDEX	27

    { /* 0xA044 */  PBSetFPos,	PBSetFPos	/* 28 */ },
#define SETFPOSTRAP	0x44
#define SETFPOSINDEX	28

    { /* 0xA045 */  PBFlushFile,	PBFlushFile	/* 29 */ },
#define FLUSHFILETRAP	0x45
#define FLUSHFILEINDEX	29

};

osstuff_t osstuff[0x100] = {
    { (void *) 0, PBOpen },
    { (void *) 0, PBClose },
    { (void *) 0, PBRead },
    { (void *) 0, PBWrite },
    { (void *) 0, PBControl },
    { (void *) 0, PBStatus },
    { (void *) 0, PBKillIO },
    { (void *) 0, PBGetVInfo },
    { (void *) 0, PBCreate },
    { (void *) 0, PBDelete },
    { (void *) 0, PBOpenRF },
    { (void *) 0, PBRename },
    { (void *) 0, PBGetFInfo },
    { (void *) 0, PBSetFInfo },
    { (void *) 0, PBUnmountVol },
    { (void *) 0, PBMountVol },
    { (void *) 0, PBAllocate },
    { (void *) 0, PBGetEOF },
    { (void *) 0, PBSetEOF },
    { (void *) 0, PBFlushVol },
    { (void *) 0, PBGetVol },
    { (void *) 0, PBSetVol },
    { (void *) 0, _FInitQueue },
    { (void *) 0, PBEject },
    { (void *) 0, PBGetFPos },
    { (void *) 0, _InitZone },
    { (void *) 0, _GetZone },
    { (void *) 0, _SetZone },
    { (void *) 0, _FreeMem },
    { (void *) 0, _MaxMem },
    { (void *) 0, _NewPtr },
    { (void *) 0, _DisposPtr },
    { (void *) 0, _SetPtrSize },
    { (void *) 0, _GetPtrSize },
    { (void *) 0, _NewHandle },
    { (void *) 0, _DisposHandle },
    { (void *) 0, _SetHandleSize },
    { (void *) 0, _GetHandleSize },
    { (void *) 0, _HandleZone },
    { (void *) 0, _ReallocHandle },
    { (void *) 0, _RecoverHandle },
    { (void *) 0, _HLock },
    { (void *) 0, _HUnlock },
    { (void *) 0, _EmptyHandle },
    { (void *) 0, _InitApplZone },
    { (void *) 0, _SetApplLimit },
    { (void *) 0, _BlockMove },
    { (void *) 0, _PostEvent },
    { (void *) 0, _OSEventAvail },
    { (void *) 0, _GetOSEvent },
    { (void *) 0, _FlushEvents },
    { (void *) 0, _VInstall },
    { (void *) 0, _VRemove },
    { (void *) 0, PBOffLine },
    { (void *) 0, _MoreMasters },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _WriteParam },
    { (void *) 0, _ReadDateTime },
    { (void *) 0, _SetDateTime },
    { (void *) 0, _Delay },
    { (void *) 0, _EqualString },
    { (void *) 0, _DrvrInstall },
    { (void *) 0, _DrvrRemove },
    { (void *) 0, _InitUtil },
    { (void *) 0, _ResrvMem },
    { (void *) 0, PBSetFLock },
    { (void *) 0, PBRstFLock },
    { (void *) 0, PBSetFVers },
    { (void *) 0, PBSetFPos },
    { (void *) 0, PBFlushFile },
    { (void *) 0, _GetTrapAddress },
    { (void *) 0, _SetTrapAddress },
    { (void *) 0, _PtrZone },
    { (void *) 0, _HPurge },
    { (void *) 0, _HNoPurge },
    { (void *) 0, _SetGrowZone },
    { (void *) 0, _CompactMem },
    { (void *) 0, _PurgeMem },
    { (void *) 0, _AddDrive },
    { (void *) 0, _RDrvrInstall },
    { (void *) 0, _RelString },
    { (void *) 0, _IMVI_ReadXPRam },
    { (void *) 0, _IMVI_WriteXPRam },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _UprString },
    { (void *) 0, _StripAddress },
    { (void *) 0, _IMVI_LowerText },
    { (void *) 0, _SetApplBase },
    { (void *) 0, _InsTime },
    { (void *) 0, _RmvTime },
    { (void *) 0, _PrimeTime },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _IMVI_MemoryDispatch },
    { (void *) 0, _SwapMMUMode },
    { (void *) 0, _NMInstall },
    { (void *) 0, _NMRemove },
    { (void *) 0, _HFSDispatch },
    { (void *) 0, _MaxBlock },
    { (void *) 0, _PurgeSpace },
    { (void *) 0, _MaxApplZone },
    { (void *) 0, _MoveHHi },
    { (void *) 0, _StackSpace },
    { (void *) 0, _NewEmptyHandle },
    { (void *) 0, _HSetRBit },
    { (void *) 0, _HClrRBit },
    { (void *) 0, _HGetState },
    { (void *) 0, _HSetState },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _SlotManager },
    { (void *) 0, _SlotVInstall },
    { (void *) 0, _SlotVRemove },
    { (void *) 0, _AttachVBL },
    { (void *) 0, _DoVBLTask },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _DTInstall },
    { (void *) 0, _SIntRemove },
    { (void *) 0, _CountADBs },
    { (void *) 0, _GetIndADB },
    { (void *) 0, _GetADBInfo },
    { (void *) 0, _SetADBInfo },
    { (void *) 0, _ADBReInit },
    { (void *) 0, _ADBOp },
    { (void *) 0, _GetDefaultStartup },
    { (void *) 0, _SetDefaultStartup },
    { (void *) 0, _InternalWait },
    { (void *) 0, _GetVideoDefault },
    { (void *) 0, _SetVideoDefault },
    { (void *) 0, _SIntInstall },
    { (void *) 0, _SetOSDefault },
    { (void *) 0, _GetOSDefault },
    { (void *) 0, _IMVI_IdleUpdate },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _IMVI_SlpQInstall },
    { (void *) 0, _CommToolboxDispatch },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _IMVI_DebugUtil },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _IMVI_DeferUserFn },
    { (void *) 0, _SysEnvirons },
    { (void *) 0, _IMVI_Translate24To32 },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Microseconds },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _HWPriv },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Gestalt },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _flushcache },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _IMVI_PPC },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _ResourceStub },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
    { (void *) 0, _Unimplemented },
};

PUBLIC void filltables( void )
{
    int i, fsindex;
    syn68k_addr_t unimpl = 0;

    unimpl = callback_install( (callback_handler_t) _Unimplemented,
								   (void *) 0);

    for (i = 0; i < (int) NELEM(tooltraptable); ++i)
	tooltraptable[i] = toolstuff[i].orig = (void *)
	   ((toolstuff[i].ptoc.wheretogo == _Unimplemented) ?
	       unimpl
	   :
	       callback_install( (callback_handler_t)
				   (toolstuff[i].ptoc.magic != (ULONGINT) -1 ?
				       PascalToCCall
				   :
				       toolstuff[i].ptoc.wheretogo),
						         &toolstuff[i].ptoc ));

    for (i = 0; i < (int) NELEM(pstuff); ++i)
      pstuff[i].orig = ((void *)
			((pstuff[i].ptoc.wheretogo == _Unimplemented)
			 ? SYN68K_TO_US (unimpl)
			 : SYN68K_TO_US (callback_install((callback_handler_t) 
					    ((pstuff[i].ptoc.magic
					      != (ULONGINT) -1)
					     ? PascalToCCall
					     : pstuff[i].ptoc.wheretogo),
							  &pstuff[i].ptoc ))));

    for (i = 0; i < (int) NELEM(ostraptable); ++i) {
	switch (i) {
	case OPENTRAP:
	    fsindex = OPENINDEX;
	    break;
	case CLOSETRAP:
	    fsindex = CLOSEINDEX;
	    break;
	case READTRAP:
	    fsindex = READINDEX;
	    break;
	case WRITETRAP:
	    fsindex = WRITEINDEX;
	    break;
	case CONTROLTRAP:
	    fsindex = CONTROLINDEX;
	    break;
	case STATUSTRAP:
	    fsindex = STATUSINDEX;
	    break;
	case KILLIOTRAP:
	    fsindex = KILLIOINDEX;
	    break;
	case GETVINFOTRAP:
	    fsindex = GETVINFOINDEX;
	    break;
	case CREATETRAP:
	    fsindex = CREATEINDEX;
	    break;
	case DELETETRAP:
	    fsindex = DELETEINDEX;
	    break;
	case OPENRFTRAP:
	    fsindex = OPENRFINDEX;
	    break;
	case RENAMETRAP:
	    fsindex = RENAMEINDEX;
	    break;
	case GETFINFOTRAP:
	    fsindex = GETFINFOINDEX;
	    break;
	case SETFINFOTRAP:
	    fsindex = SETFINFOINDEX;
	    break;
	case UNMOUNTVOLTRAP:
	    fsindex = UNMOUNTVOLINDEX;
	    break;
	case MOUNTVOLTRAP:
	    fsindex = MOUNTVOLINDEX;
	    break;
	case ALLOCATETRAP:
	    fsindex = ALLOCATEINDEX;
	    break;
	case GETEOFTRAP:
	    fsindex = GETEOFINDEX;
	    break;
	case SETEOFTRAP:
	    fsindex = SETEOFINDEX;
	    break;
	case FLUSHVOLTRAP:
	    fsindex = FLUSHVOLINDEX;
	    break;
	case GETVOLTRAP:
	    fsindex = GETVOLINDEX;
	    break;
	case SETVOLTRAP:
	    fsindex = SETVOLINDEX;
	    break;
	case EJECTTRAP:
	    fsindex = EJECTINDEX;
	    break;
	case GETFPOSTRAP:
	    fsindex = GETFPOSINDEX;
	    break;
	case OFFLINETRAP:
	    fsindex = OFFLINEINDEX;
	    break;
	case SETFLOCKTRAP:
	    fsindex = SETFLOCKINDEX;
	    break;
	case RSTFLOCKTRAP:
	    fsindex = RSTFLOCKINDEX;
	    break;
	case SETFVERSTRAP:
	    fsindex = SETFVERSINDEX;
	    break;
	case SETFPOSTRAP:
	    fsindex = SETFPOSINDEX;
	    break;
	case FLUSHFILETRAP:
	    fsindex = FLUSHFILEINDEX;
	    break;
	default:
	    fsindex = -1;
	    break;
	};

 	if (fsindex == -1)
	    ostraptable[i] = osstuff[i].orig = (void *)
			   ((osstuff[i].func == _Unimplemented) ?
			       unimpl
			   :
			       callback_install( osstuff[i].func,
							     osstuff[i].func));
	else {
	    osstuff[i].func = (void *) _HFSRoutines;
	    ostraptable[i] = osstuff[i].orig = (void *)
			   callback_install( (void *) _HFSRoutines,
						         fsroutines[fsindex] );
	}
    }
}
